Attribute VB_Name = "vrnlib_test_auto"
Option Base 1
Public param1 As Double
Public param2 As Double
Public param3 As Double

Public CurrentRefr As String



Sub ListRegion(Refr As String)
  Dim Regprocs As New Collection
  
  CurrentRefr = Refr
  
  RegName = Array("Max/min og kritiske verdier", "Mettet vske", "Mettet gass", "To-fase omrde", _
                "Overhetet gass", "Vilkrlig omrde")
              
  For i = 1 To UBound(RegName)
    Regprocs.Add RegName(i), RegName(i)
  Next i

  Regioner.Liste.Clear
 
  For Each Item In Regprocs
     Regioner.Liste.AddItem Item
  Next Item
  
  Regioner.Show
End Sub


Sub ListCritFunc()
  Dim Critfuncs As New Collection
 
  CritName = Array("tsatmin", "tsatmax", "tgasmax", "vmin", "vmax", "psatmin", "psatmax", "pgasmas", "Molw", "Tcrit", "Pcrit", "Vcrit", _
                   "DVTliqmin", "DVTliqmax", "DVTgasmin", "DVTgasmax", _
                   "TCTliqmin", "TCTliqmax", "TCTgasmin", "TCTgasmax")
                    
            
  For i = 1 To UBound(CritName)
    Critfuncs.Add CritName(i), CritName(i)
  Next i

 
  Critlist.Liste.Clear
 
  For Each Item In Critfuncs
     Critlist.Liste.AddItem Item
  Next Item
  
  Critlist.Label1.Caption = "Velg funksjon"
  Critlist.Show
End Sub


Sub ListLiqsatFunc()

  Dim Liqsatfuncs As New Collection
  
  LiqsatName = Array("Temp(p)", "Temp(Entalpi)", "Temp(Entropi)", _
               "Trykk(Temp)", "Entalpi(Temp)", "Entropi(Temp)", "Volum(Temp)", "cp(Temp)", _
               "Termisk konduktivitet(Temp)", "Dynamisk viskositet (Temp)")
               

  For i = 1 To UBound(LiqsatName)
    Liqsatfuncs.Add LiqsatName(i), LiqsatName(i)
  Next i
 
  Liqsatlist.Liste.Clear
 
  For Each Item In Liqsatfuncs
     Liqsatlist.Liste.AddItem Item
  Next Item
  
  Liqsatlist.Label1.Caption = "Velg funksjon"
  Liqsatlist.Show
  
End Sub

Sub ListVapsatFunc()

  Dim Vapsatfuncs As New Collection
  Dim VapsatName
 
  VapsatName = Array("Temp(p)", "Temp(Entalpi)", "Temp(Entropi)", _
               "Trykk(Temp)", "Entalpi(Temp)", "Entropi(Temp)", "Volum(Temp)", "cp(Temp)", _
               "Termisk konduktivitet(Temp)", "Dynamisk viskositet (Temp)")
               
  For i = 1 To UBound(VapsatName)
    Vapsatfuncs.Add VapsatName(i), VapsatName(i)
  Next i

  Vapsatlist.Liste.Clear
 
  For Each Item In Vapsatfuncs
     Vapsatlist.Liste.AddItem Item
  Next Item
  
  Vapsatlist.Label1.Caption = "Velg funksjon"
  Vapsatlist.Show
  
End Sub

Sub ListGasFunc()

  Dim Gasfuncs As New Collection
  Dim GasName

  GasName = Array("Temp(h,p)", "Temp(s,p)", "Temp(v,p)", "Temp(s,v)", "Trykk(t,s)", "Trykk(t,v)", _
               "h(t,p)", "h(s,p)", "h(t,v)", "s(t,p)", "s(t,v)", _
               "v(t,p)", "cp(t,p)", "tc(t,p)", "dv(t,p)")
               
  For i = 1 To UBound(GasName)
    Gasfuncs.Add GasName(i), GasName(i)
  Next i

 
  Gaslist.Liste.Clear
 
  For Each Item In Gasfuncs
     Gaslist.Liste.AddItem Item
  Next Item
  
  Gaslist.Show

End Sub

Sub ListTwophaseFunc()
  Dim Tphfuncs As New Collection
  Dim TphName

  TphName = Array("Hlqgs(t,x)", "Xlqgs(t,h)", "DHlqgs(t)", "DHlqgs(p)", _
                  "Slqgs(t,x)", "Slqgs(t,h)")
 
  For i = 1 To UBound(TphName)
    Tphfuncs.Add TphName(i), TphName(i)
  Next i
 
  Twophaselist.Liste.Clear
 
  For Each Item In Tphfuncs
     Twophaselist.Liste.AddItem Item
  Next Item
  
  Twophaselist.Show

End Sub


Sub ListGenFunc()
  Dim Genfuncs As New Collection
  Dim GenName
  Dim GenInfo
  Dim GenFuncName
 
  GenName = Array("T(h,p)", "T(s,p)", "h(s,p)", "h(v,t)", _
                  "h(t,p,x)", "s(t,h)", "s(t,p,x)", "v(t,p,x)", "cp(t,p,x)", _
                  "tc(t,p,x)", "dv(t,p,x)", "w(t,p)")
               

  For i = 1 To UBound(GenName)
    Genfuncs.Add GenName(i), GenName(i)
  Next i

 
  Genlist.Liste.Clear
 
  For Each Item In Genfuncs
     Genlist.Liste.AddItem Item
  Next Item
  
  Genlist.Show
End Sub

Sub ListRefrigerants()
Attribute ListRefrigerants.VB_Description = "Velger kuldemedium fra liste"
Attribute ListRefrigerants.VB_ProcData.VB_Invoke_Func = "r\n14"
  
  Dim Refrigerants As New Collection
  
  Refrlist = Array("R11", "R12", "R13", "R13B1", "R14", "R22", "R23", _
             "R32", "R113", "R114", "R123", "R123a", "R124", "R125", _
             "R134", "R134a", "R141b", "R143a", "R152a", "R290", "R404A", _
             "R407A", "R407B", "R407C", "R410A", "R411", "R500", "R502", _
             "R507", "R508B", "R600", "R600a", "R717", "R717_", "R718", _
             "R719", "R744", "R1270", "HK1", "HK2", "HK3", "HK0")

  Infolist = Array("", "", "", "", "", "", "", _
             "", "", "", "", "", "", "", _
             "", "", "", "", "", "", "", _
             "", "", "", "(AZ-20)", "(R410 fra DuPont)", "", "", _
             "(AZ-50),", "", "", "", "(NH3)", "(NH3 Overkritisk)", "(Vann)", _
             "(Metanol)", "CO2", "", "", "", "", "")

  For i = 1 To UBound(Refrlist)
      Refrigerants.Add Refrlist(i) + " " + Infolist(i), Refrlist(i)
  Next i

  Kuldemedia.Liste.Clear
  
  For Each Item In Refrigerants
      Kuldemedia.Liste.AddItem Item
  Next Item
  
  Kuldemedia.Show
End Sub

Sub setCalcParameter1(dparam1 As Double)
 param1 = dparam1
End Sub

Function getCalcParameter1() As Double
  getCalcParameter1 = param1
End Function

Sub setCalcParameter2(dparam1 As Double)
 param2 = dparam2
End Sub

Function getCalcParameter2() As Double
  getCalcParameter2 = param2
End Function

Sub Calculate0(rfunc)
 ActiveCell.FormulaR1C1 = "=" + rfunc + "(" + """" + CurrentRefr + """" + ")"
End Sub

Sub Calculate1(rfunc, rinfo, rparam1)
 Beregn1.Rmed = CurrentRefr
 Beregn1.Funksjonsnavn = rinfo
 Beregn1.Parameter1 = rparam1
 Beregn1.Show
 If param1 > -999 Then
 ActiveCell.FormulaR1C1 = "=" + rfunc + "(" + """" + CurrentRefr + """" + "," + CStr(param1) + ")"
 End If
End Sub

Sub Calculate2(rfunc, rinfo, rparam1, rparam2)
 Beregn2.Rmed = CurrentRefr
 Beregn2.Funksjonsnavn = rinfo
 Beregn2.Parameter1 = rparam1
 Beregn2.PArameter2 = rparam2
 Beregn2.Show
 If param1 > -999 Then
 ActiveCell.FormulaR1C1 = "=" + rfunc + "(" + """" + CurrentRefr + """" + "," + CStr(param1) + "," + CStr(param2) + ")"
 End If
End Sub

Sub Calculate3(rfunc, rinfo, rparam1, rparam2, rparam3)
 Beregn3.Rmed = CurrentRefr
 Beregn3.Funksjonsnavn = rinfo
 Beregn3.Parameter1 = rparam1
 Beregn3.PArameter2 = rparam2
 Beregn3.Parameter3 = rparam3
 Beregn3.Show
 If param1 > -999 Then
 ActiveCell.FormulaR1C1 = "=" + rfunc + "(" + """" + CurrentRefr + """" + "," + CStr(param1) + "," + CStr(param2) + ")"
 End If
End Sub

Sub Auto_open()
  Const CatName = "Rnlib"
  Const NbFuncs = 72
  Dim i As Integer
  Dim Cat As String
  Dim LCat As Integer
  Dim FctName

  FctName = Array("r_ssatliq_t", "r_cpsatgas_t", "r_cpsatliq_t", "r_cpx_tpx", "r_dhlqgs_p", "r_dhlqgs_t", "r_dvgas_tp", "r_dvsatgas_t", _
        "r_dvsatliq_t", "r_dvtgasmax", "r_dvtgasmin", "r_dvtliqmax", "r_dvtliqmin", "r_dvx_tpx", "r_hgas_sp", "r_hgas_tp", "r_hgas_tv", _
        "r_hlqgs_tx", "r_hsatgas_t", "r_hsatliq_t", "r_hx_sp", "r_hx_tpx", "r_hx_vt", "r_molw", "r_pcrit", "r_pgas_ts", "r_pgas_tv", _
        "r_pmax", "r_pmin", "r_psatgas_t", "r_psatliq_t", "r_sgas_tp", "r_sgas_tv", "r_slqgs_th", "r_slqgs_tx", "r_ssatgas_t", "r_cpgas_tp", _
        "r_stsatliq_t", "r_sx_th", "r_sx_tpx", "r_tcgas_tp", "r_tcrit", "r_tcsatgas_t", "r_tcsatliq_t", "r_tctgasmax", "r_tctgasmin", _
        "r_tctliqmax", "r_tctliqmin", "r_tcx_tpx", "r_tgas_hp", "r_tgas_sp", "r_tgas_sv", "r_tgas_vp", "r_tgasmax", "r_tsatgas_p", "r_tsatgas_s", _
        "r_tsatgas_v", "r_tsatliq_h", "r_tsatliq_p", "r_tsatliq_s", "r_tsatmax", "r_tsatmin", "r_tx_hp", "r_tx_sp", "r_vcrit", "r_vgas_tp", _
        "r_vmax", "r_vmin", "r_vsatgas_t", "r_vsatliq_t", "r_vx_tpx", "r_xlqgs_th")

  Application.ScreenUpdating = False
  ThisWorkbook.IsAddin = False
  LCat = 14

  Do
    LCat = LCat + 1
    Application.ExecuteExcel4Macro _
    "DEFINE.NAME(""Djzh" & LCat & """,0,2,,," & LCat & ")"
    Cat = Names("Djzh" & LCat).Category
  Loop While Cat <> "User Defined" And Cat <> CatName

  If Cat = "User Defined" Then _
    Application.ExecuteExcel4Macro _
    "DEFINE.NAME(""Djzh" & LCat & """,0,2,,,""" & CatName & """)"

  For i = 1 To NbFuncs
    Application.MacroOptions Macro:=FctName(i), Category:=LCat
  Next i

  For i = 15 To LCat
    Application.ExecuteExcel4Macro "DELETE.NAME(""Djzh" & i & """)"
  Next i

  ThisWorkbook.IsAddin = True
  ThisWorkbook.Saved = True

  MsgBox ("RnLib er lastet inn." + Chr(10) + Chr(13) + _
          "<CTRL>+<r> viser liste av gyldige medium")

End Sub

